config/routes.rb
Rails.application.routes.draw do
  resources :articles
  resources :categories
  resources :vats
  resources :projects
  resources :users
  resources :interventions
  resources :partners

  root 'partners#index'

  resource :user_sessions, only: [:create, :new, :destroy]

  get 'logout' => 'user_sessions#destroy', :as => :logout

  get 'login' => 'user_sessions#login', :as => :login

  post 'get_token' => 'user_sessions#get_token'

  get 'partners/:id/interventions' => 'partners#interventions'

	get 'partners/:id/projects' => 'partners#projects'

  get 'users/:id/interventions' => 'users#interventions'

  get 'config/' => 'config#index'

  get 'about/' => 'about#index'

end

app/models/project.rb
class Project < ActiveRecord::Base
  validates :partner_id, :presence => true
  belongs_to :partner
  has_many :inteventions

  def full_title
    return "#{self.partner.name} - #{self.title}"
  end

  def duree_interventions date=nil
    interventions = Intervention.where(project_id: self.id)
    inteventions = inteventions.where("intervention_date >= ?", date) if date
    return interventions.sum(:duration)
  end
end

app/controllers/projects_controller.rb
class ProjectsController < ApplicationController
  before_action :set_project, only: [:show, :edit, :update, :destroy]
  before_action :get_partners, only: [:new, :edit]

  # GET /projects
  # GET /projects.json
  def index
    @projects = Project.includes(:partner).order("partners.name", "projects.title")
    @fullTitle = true
  end

  # GET /projects/1
  # GET /projects/1.json
  def show
    @interventions = Intervention.where(project_id: @project.id)
    @duree_intervention = @project.duree_interventions
    deg = nil
    if @duree_intervention && @project.max_hours
      deg = @duree_intervention*360/@project.max_hours
      @pourc = @duree_intervention*100/@project.max_hours
    else
      deg = 360
    end
    @deg_right = deg>=180 ? 180 : deg
    @deg_left = deg>180 ? (deg<360 ? deg-180 : 180) : 0
  end

  # GET /projects/new
  def new
    @project = Project.new
    @partners = @partners.where(id: params[:partner_id]) if params[:partner_id]
  end

  # GET /projects/1/edit
  def edit
  end

  # POST /projects
  # POST /projects.json
  def create
    @project = Project.new(project_params)

    respond_to do |format|
      if @project.save
        format.html { redirect_to @project, notice: 'Le projet a bien été créé.' }
        format.json { render :show, status: :created, location: @project }
      else
        format.html { render :new }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /projects/1
  # PATCH/PUT /projects/1.json
  def update
    respond_to do |format|
      if @project.update(project_params)
        format.html { redirect_to @project, notice: 'Le projet a été mis à jour.' }
        format.json { render :show, status: :ok, location: @project }
      else
        format.html { render :edit }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /projects/1
  # DELETE /projects/1.json
  def destroy
    @project.destroy
    respond_to do |format|
      format.html { redirect_to projects_url, notice: 'Le projet a été supprimé.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_project
      @project = Project.find(params[:id])
    end

    def get_partners
      @partners = Partner.order(:name)
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def project_params
      params.require(:project).permit(:title, :partner_id, :echance, :description, :facturable, :max_hours)
    end
end

app/helpers/projects_helper.rb
module ProjectsHelper
end

app/views/projects/_form.html.erb
<%= form_for(@project) do |f| %>
  <% if @project.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@project.errors.count, "error") %> prohibited this project from being saved:</h2>

      <ul>
      <% @project.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="control-group">
	  <div class="field input-group">
			<span class="input-group-addon" title="Titre"><i class="fa fa-pencil fa-fw"></i></span>
      <%= f.text_field :title, class: "form-control", placeholder: "Titre", value: @project.title %>
    </div>
  </div>
  <div class="control-group">
	  <div class="field input-group">
			<span class="input-group-addon" title="Date de naissance"><i class="fa fa-user fa-fw"></i></span>
      <%= f.select(:partner_id, [], {}, class: "form-control" ) do %>
        <% @partners.each do |partner| %>
          <%= content_tag(:option, partner.name, value: partner.id, selected: (partner.id==@project.partner_id)) %>
        <% end %>
  		<% end %>
    </div>
  </div>
  <div class="control-group">
	  <div class="field input-group">
			<span class="input-group-addon" title="Echéance"><i class="fa fa-calendar fa-fw"></i></span>
      <%= f.text_field :echance, class: "datepicker form-control", placeholder: "Echéance", value: @project.echance && @project.echance.strftime("%d/%m/%Y") %>
    </div>
  </div>
  <div class="control-group">
	  <div class="field input-group">
			<span title="Main d'oeuvre facturable ?">Main d'oeuvre facturable ?</span>
      <%= f.check_box :facturable, value: @project.facturable ? 1 : 0, class: "my-checkbox" %>

    </div>
  </div>
  <div class="control-group">
	  <div class="field input-group">
			<span class="input-group-addon" title="Nombre d'heure maximum pour ce projet"><i class="fa fa-clock-o fa-fw"></i></span>
      <%= f.number_field :max_hours, class: "form-control", placeholder: "Nombre d'heure maximum pour ce projet", value: @project.max_hours %>
    </div>
  </div>
  <div class="control-group">
	  <div class="field input-group">
			<span class="input-group-addon" title="Echéance"><i class="fa fa-calendar fa-fw"></i></span>
      <%= f.text_area :description, class: "form-control", placeholder: "Description", value: @project.description, rows:"20"  %>
    </div>
  </div>
  <div class="actions">
    <%= f.submit "Valider", class: "btn btn-primary", id: "validateButton" %> ou
    <%= link_to 'Retour', (@project.id ? project_path(@project) : projects_path) %>
  </div>

<% end %>

app/views/projects/_tables_projects.html.erb
<table id="table"
     data-classes="table table-hover table-condensed"
     data-striped="true"
     data-toolbar="#toolbar"
     data-pagination="true"
     data-click-to-select="false"
     data-search="true"
     data-show-export="true"
     data-reorderable-columns="true"
     data-show-refresh="true"
     data-show-pagination-switch="true">
  <thead>
    <tr>
      <th>Projet/Contrat</th>
      <th>Echance</th>
      <th></th>
    </tr>
  </thead>

  <tbody>
    <% @projects.each do |project| %>
      <tr>
        <td>
          <%= @fullTitle ? project.full_title : project.title %>
          <span class="cell-icon">
            <a href="<%= project_path(project) %>"><i class="fa fa-external-link"></i></a>
          </span>
        </td>
        <td><%= project.echance && project.echance.strftime("%d/%m/%Y") %></td>
        <td>
          <%= link_to project, method: :delete, data: { confirm: 'Etes-vous sûr de vouloir supprimer cette feuille ?' } do %>
            <i class="fa fa-trash fa-fw"></i>
          <% end %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/projects/edit.html.erb
<div class="titre_actif">
  <h1>Modifier projet/contrat</h1>
</div>

<%= render 'form' %>

app/views/projects/index.html.erb
<div class="titre_actif">
  <div class="toolbar">
    <%= link_to new_project_path, class: "btn btn-primary" do %>
      <i class="fa fa-plus fa-3x"></i>
    <% end %>
  </div>
  <h1>Projets/Contrats</h1>
  <span class="title-tag">
    <i class="fa fa-briefcase fa-4x"></i>
  </span>
</div>

<%= render 'tables_projects' %>

app/views/projects/new.html.erb
<div class="titre_actif">
  <h1>Nouveau projet/contrat</h1>
</div>

<%= render 'form' %>

app/views/projects/show.html.erb
<style type="text/css">
  @keyframes loading-right{
      0%{
          -webkit-transform: rotate(0deg);
          transform: rotate(0deg);
      }
      100%{
          -webkit-transform: rotate(<%=@deg_right%>deg);
          transform: rotate(<%=@deg_right%>deg);
      }
  }
  @keyframes loading-left{
      0%{
          -webkit-transform: rotate(0deg);
          transform: rotate(0deg);
      }
      100%{
          -webkit-transform: rotate(<%=@deg_left%>deg);
          transform: rotate(<%=@deg_left%>deg);
      }
  }
</style>

<div class="titre_actif">
  <div class="toolbar">
    <%= link_to edit_project_path(@project), class: "btn btn-primary" do %>
      <i class="fa fa-pencil fa-3x"></i>
    <% end %>
  </div>
  <h1><%= @project.title %></h1>
  <span class="title-tag">
    <i class="fa fa-briefcase fa-4x"></i>
  </span>
</div>

<div class="col-md-9 left">
  <div class="field input-group">
    <span class="input-group-addon"><div class="span-label">Client</div></span>
    <div class="form-control"><%= @project.partner && @project.partner.name %></div>
  </div>
  <div class="field input-group">
    <span class="input-group-addon"><div class="span-label">Echéance</div></span>
    <div class="form-control"><%= @project.echance && @project.echance.strftime("%d/%m/%Y") %></div>
  </div>
  <div class="field input-group">
    <span class="input-group-addon"><div class="span-label">Nombre d'heures réalisées</div></span>
    <div class="form-control"><%= @duree_intervention %> h</div>
  </div>
  <div class="field input-group">
    <span class="input-group-addon"><div class="span-label">Nombre d'heures maximum</div></span>
    <div class="form-control"><%= @project.max_hours.to_i %> h</div>
  </div>
  <div class="field input-group">
    <span class="input-group-addon"><div class="span-label">Main d'oeuvre facturable ?</div></span>
    <div class="form-control"><%= @project.facturable ? "oui" : "non" %></div>
  </div>
</div>
<div class="col-md-3">
      <div class="progress red">
        <span class="progress-left">
          <span class="progress-bar"></span>
        </span>
        <span class="progress-right">
          <span class="progress-bar"></span>
        </span>
        <div class="progress-value"><%= "#{@pourc.to_i>0 ? @pourc.to_s+' %' : @duree_intervention.to_i.to_s + ' h'}" %></div>
      </div>
</div>

<div class="col-md-12">
  <div class="tabbable-panel">
  	<div class="tabbable-line">
  		<ul class="nav nav-tabs ">
  			<li class="active">
  				<a href="#tab_description" data-toggle="tab">
  				Description </a>
  			</li>
  			<li>
  				<a href="#tab_interventions" data-toggle="tab">
  				Interventions </a>
  			</li>
        <li>
  				<a href="#tab_stats" data-toggle="tab">
  				Stats </a>
  			</li>
  		</ul>
  		<div class="tab-content">
  			<div class="tab-pane active" id="tab_description">
          <div class="well left">
            <%= simple_markdown(@project.description) %>
          </div>
  			</div>
  			<div class="tab-pane" id="tab_interventions">
  				<%= render 'interventions/tables_interventions' %>
  			</div>
        <div class="tab-pane" id="tab_stats">
          <div class="col-md-12">
			      <%= area_chart @interventions.group_by_month(:intervention_date).sum(:duration), colors: ["#760000"] %>
          </div>
          <div class="col-md-6">
			      <%= pie_chart @interventions.joins(:user).group("users.name").sum(:duration), colors: ["#760000", "#984040"] %>
          </div>
          <div class="col-md-6">
          </div>
          <div class='end_page'></div>
        </div>
  		</div>
  	</div>
  </div>
</div>